using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;

namespace WindowsApplication1 {
	/// <summary>
	/// A simple example to show how a cursor can be made to be blink
	/// using a secondary thread.
	/// 
	/// Ben Bederson
	/// University of Maryland
	/// May 2005
	/// </summary>
	public class BlinkingCursorThread : System.Windows.Forms.Form {
		private System.ComponentModel.Container components = null;
		private bool cursorVisible = false;
		private Thread cursorThread = null;

		public BlinkingCursorThread() {
			InitializeComponent();

			Load += new EventHandler(BlinkingCursorThread_Load);
			Closing += new CancelEventHandler(BlinkingCursorThread_Closing);
		}

		protected override void OnPaint(PaintEventArgs e) {
			base.OnPaint (e);

			if (cursorVisible) {
				e.Graphics.DrawLine(Pens.Blue, 10, 10, 10, 100);
			}
		}

		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if (components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			this.Size = new System.Drawing.Size(300,300);
			this.Text = "Form1";
		}
		#endregion

		[STAThread]
		static void Main() {
			Application.Run(new BlinkingCursorThread());
		}

		private void CursorProc() {
			while (true) {
				cursorVisible = !cursorVisible;
				BeginInvoke(new MethodInvoker(Invalidate));
				Thread.Sleep(500);
			}
		}

		private void BlinkingCursorThread_Load(object sender, EventArgs e) {
			cursorThread = new Thread(new ThreadStart(CursorProc));
			cursorThread.Start();
		}

		private void BlinkingCursorThread_Closing(object sender, CancelEventArgs e) {
			cursorThread.Abort();
			cursorThread = null;
		}
	}
}